﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Controls.Primitives;

namespace XamComboEditorEdit
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
           
            DataContext = new ViewModel();                       
        }  
    }

    public class ViewModel
    {
        public ObservableCollection<DataItem>  SourceCollection
        {
            get
            {
                return new ObservableCollection<DataItem>()
                {
                    new DataItem { ID = 1, Name = new FullName(){ FirstName = "Item", LastName = "1" }},
                    new DataItem { ID = 2, Name = new FullName(){ FirstName = "Item", LastName = "2" }},
                    new DataItem { ID = 3, Name = new FullName(){ FirstName = "Item", LastName = "3" }},
                    new DataItem { ID = 4, Name = new FullName(){ FirstName = "Item", LastName = "4" }},
                    new DataItem { ID = 1, Name = new FullName(){ FirstName = "Item", LastName = "5" }},
                    new DataItem { ID = 2, Name = new FullName(){ FirstName = "Item", LastName = "6" }},
                    new DataItem { ID = 3, Name = new FullName(){ FirstName = "Item", LastName = "7" }},
                    new DataItem { ID = 4, Name = new FullName(){ FirstName = "Item", LastName = "8" }},
                };
            }
        }       
    }

    public class DataItem : INotifyPropertyChanged
    {
        private int id;
        private FullName name;

        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                Update("ID");
            }
        }

        public FullName Name
        {
            get { return name; }
            set
            {
                name = value;
                Update("Name");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void Update(string prop)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
    }

    public class FullName : INotifyPropertyChanged
    {
        private string firstName;
        private string lastName;
        
        public string FirstName
        {
            get { return firstName; }
            set
            {
                firstName = value;
                Update("FirstName");
            }
        }

        public string LastName
        {
            get { return lastName; }
            set
            {
                lastName = value;
                Update("LastName");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void Update(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

}
